#ifndef __MFBO2_H
#define __MFBO2_H

/****************************************************************************/

#ifndef MFBO_INT
#  ifdef __WIN32__
#    ifdef __DLL__
#      define MFBO_INT int _export
#    else
#      define MFBO_INT extern "C" int _stdcall
#    endif
#  else
#    ifdef __DLL__
#      define MFBO_INT int far pascal _export
#    else
#      define MFBO_INT int far pascal
#    endif
#  endif
#endif

#ifndef __MFPARAM
#define __MFPARAM
#endif

#ifndef __MFVPARAM
#define __MFVPARAM void
#endif


/******************************  kody bledow  *******************************/
#define mfeOk             0  /* Wykonanie poprawne */

#define mfeImplementation 1
#define mfeApplication  (-1)
#define mfeFunction     (-2)
#define mfeAssociation  (-3)
#define mfeAccess       (-4)


#define mfeHardware    0x0101 /* Bd sprztowy w czci fiskalnej */
#define mfeReserves1   0x0102 /* Wyczerpane zasoby nieodzyskiwalne */
#define mfeInitialize1 0x0103 /* Modu niezainicjowany */

#define mfeDisplay     0x0201 /* Brak komunikacji z wywietlaczem */
#define mfePrinter     0x0202 /* Bd komunikacji z drukark */
#define mfeBattery     0x0203 /* Niskie napicie baterii */
#define mfeReserves2   0x0204 /* Wyczerpane zasoby odzyskiwalne */
#define mfeFirmware    0x0205 /* Bd sprztowy w czci niefiskalnej */
#define mfeInitialize2 0x0206 /* Modu nie zainicjowany przez serwisanta */

#define mfeAnyError     0x0301 /* Inny bd */
#define mfeNesting      0x0302 /* Niedopuszczalne zagniedenie funkcji */
#define mfeOutOfRange   0x0303 /* Przekroczenie zakresu */
#define mfeBadTaxRate   0x0304 /* Za stawka podatkowa */
#define mfeBadSellName  0x0305 /* Towar nie moe by sprzedany */
#define mfeBadDefName   0x0306 /* Towar nie moe by zdefiniowany */
#define mfeNoClkChng    0x0307 /* Przestawienie zegara niemoliwe */
#define mfeReserve2     0x0308 /* Niepoprawny numer seryjny */
#define mfeShiftOpen    0x0309 /* Zmiana otwarta */
#define mfeShiftClose   0x030A /* Zmiana zamknita */
#define mfeReceiptOpen  0x030B /* Paragon w druku */
#define mfeReceiptClose 0x030C /* Paragon nie jest w druku */
#define mfeNoMoreShift  0x030D /* Limit zmian wyczerpany */
#define mfeInvFormat    0x030E /* Brak denominacji */
#define mfeHDDErr       0x030F /* Bd komunikacji z dyskiem */
#define mfeOutOfPaper   0x0310 /* Brak papieru */


#ifdef __cplusplus
extern "C" {
#endif

/****************************************************************************/
/* 2. Funkcje informacyjne                                                  */
/****************************************************************************/

/* 2.1. Odczyt czasu zegara wewnetrznego drukarki fiskalnej */
MFBO_INT mfGetTime( int *hour, int *minute __MFPARAM );

/* 2.2. Odczyt daty zegara wewnetrznego drukarki fiskalnej */
MFBO_INT mfGetDate( int *year, int *month, int *day __MFPARAM );

/* 2.3. Odczyt wersji drukarki fiskalnej */
MFBO_INT mfGetVersion( int *version, int *subVersion __MFPARAM );

/* 2.4. Wspolczynnik wolnych zasobow */
MFBO_INT mfGetCoefficient( int *reCoefficient, int *unCoefficient __MFPARAM );

/* 2.5. Odczyt numeru ostatniego paragonu */
MFBO_INT mfGetLastTicketNo( long *lastTicketNo __MFPARAM );

/* 2.6. Odczyt stawek podatkowych */
MFBO_INT mfGetTax( int *taxA, int *taxB, int *taxC, int *taxD, int *taxE, int *taxF __MFPARAM );


/****************************************************************************/
/* 3. Funkcje informacyjne stale                                            */
/****************************************************************************/

/* 3.1. Odczyt maksymalniej liczby zmian w ciagu doby */
MFBO_INT mfParMaxShiftNo( int *maxShiftNo __MFPARAM );

/* 3.2. Odczyt rodzaju biblioteki (niefiskalna/fiskalna) */
MFBO_INT mfParFiscal( int *flag __MFPARAM );

/* 3.3. Odczyt wersji biblioteki */
MFBO_INT mfParLibVersion( int *version, int *subVersion, char *name __MFPARAM );

/* 3.4. Odczyt tresci komunikatu */
MFBO_INT mfParMessage( int code, char *groupMsg, char *detailMsg __MFPARAM );

/* 3.5. Odczyt parametrow danych o towarze */
MFBO_INT mfParPLU( long *maxCode, int *length, char *setOfChar __MFPARAM );

/* 3.6. Odczyt parametrow dotyczacych formatu naglowka na paragonach */
MFBO_INT mfParHeader( int *flag, int *maxLines, int *length, char *setOfChar __MFPARAM );

/* 3.7. Odczyt danych dotyczacych parametrow wydruku paragonu */
MFBO_INT mfParTicket( int *discountDecimalPoint, int *flag __MFPARAM );



/****************************************************************************/
/* 4. Funkcje inicjujace, ustawiajace i definiujace                         */
/****************************************************************************/

/* 4.1. Dopuszczenie aplikacji */
MFBO_INT mfStart( const char *ident, int mfPortNo __MFPARAM );

MFBO_INT mfStop( __MFVPARAM );

MFBO_INT mfStart2( const char *ident,
                   int mfPortType,
                   int mfPortNo,
                   int column,
                   int emptyLine,
                   const char *endLine,
                   const char *cutPaper,
                   int taxA, int taxB, int taxC, int taxD, int taxE, int taxF,
                   int sBauds, int sParity, int sHandshake,
                   int codePage,
                   const char *inithString __MFPARAM );

/* 4.2. Definicja stopki paragonu */

/* a) SFI zwracajaca dane dotyczace formatu stopki drukowanej na paragonach */
MFBO_INT mfParFooter( int *maxLines, int *length, char*setOfChar __MFPARAM );

/* b) FP definiujaca stopke */
MFBO_INT mfDefFooter( const char *footer __MFPARAM );


/* 4.3. Definicja numeru kasy i kasjera oraz nazwy kasjera */

/* a) SFI zwracajaca dopuszczalny zakres parametrow numeracji kasy i kasjera*/
/*    oraz nazwy kasjera */
MFBO_INT mfParPOS( int *maxCashNo, int *maxCashierNo,
                   int *lengthName, char *setOfChar __MFPARAM );

/* b) FP definiujaca numer kasy i kasjera oraz nazwe kasjera */
MFBO_INT mfDefPOS( int cashNo, int cashierNo, const char *cashierName __MFPARAM );


/* 4.4. Ustawienie czasu zegara wewnetrznego drukarki fiskalnej */

/* a) SFI sprawdzajaca czy ustawienie czasu w zegarze jest wykonalne */
/*    (w danej chwili) */
MFBO_INT mfParTime( __MFVPARAM );

/* b) FP ustawiajaca czas zegara wewnetrznego drukarki fiskalnej */
MFBO_INT mfDefTime( int hour, int minute __MFPARAM );


/* 4.5. Ustawianie wewnetrznego licznika paragonow */

/* a) SFI sprawdzajaca czy ustawienie licznika paragonow jest wykonalne */
/*    (w danej chwili) */
MFBO_INT mfParCounter( __MFVPARAM );

/* b) FP ustawiajaca licznik paragonow */
MFBO_INT mfDefCounter( long *counter __MFPARAM );


/* 4.6. Odczyt i ustawianie definiowanych napisow */

/* a) SFI odczytujaca napis i parametry */
MFBO_INT mfParString( int stringID, char *string, int *maxLen __MFPARAM );

/* b) SFI redefiniujaca napis */
MFBO_INT mfDefString( int stringID, const char *string __MFPARAM );





/****************************************************************************/
/* 5. Funkcje towarowe                                                      */
/****************************************************************************/

/* 5.1.SFI zwracajace informacje o mozliwosci zaktualizowania bazy towarowej*/

/* a) SFI zwracajaca informacje o mozliwosci czesciowego zaktualizowania */
/*    bazy towarowej */
MFBO_INT mfParDefPLU( __MFVPARAM );

/* b) SFI zwracajaca informacje o mozliwosci calkowitego zaktualizowania */
/*      bazy towarowej */
MFBO_INT mfParDefAllPLU( __MFVPARAM );

/* 5.2. Rozpoczecie czesciowego ladowania towarow */
MFBO_INT mfBeDefPLU( __MFVPARAM );

/* 5.3. Rozpoczecie calkowitego ladowania towarow */
MFBO_INT mfBeDefAllPLU( __MFVPARAM );

/* 5.4. Zaladowanie jednego towaru */
MFBO_INT mfDefPLU( long no, const char *name, char taxCode __MFPARAM );

/* 5.5. Zakonczenie ladowania towarow */
MFBO_INT mfEndDefPLU( __MFVPARAM  );


/****************************************************************************/
/* 6. Funkcje obslugujace paragon fiskalny                                  */
/****************************************************************************/

/* 6.1. Rozpoczecie zmiany */
MFBO_INT mfBeginShift( const char *header __MFPARAM );

/* 6.2. Rozpoczecie wydruku paragonu */
MFBO_INT mfBeginTicket( long total __MFPARAM );

/* 6.3. Wydruk linii paragonu */
MFBO_INT mfLineTicket( long no, const char *name, char taxCode,
                       const char *unitStr,
                       long price, long quantity, long value __MFPARAM );

/* 6.4. Uniewaznienie linii paragonu */
MFBO_INT mfStornoLineTicket( long no, const char *name, char taxCode,
                             const char *unitStr,
                             long price, long quantity, long value __MFPARAM );

/* 6.5. Uniewaznienie paragonu */
MFBO_INT mfStornoTicket( __MFVPARAM );

/* 6.6. Zakonczenie wydruku paragonu */
MFBO_INT mfEndTicket( int percentDiscount, long valueDiscount,
                      long transactionNo,
                      long payment1, const char * paymStr1,
                      long payment2, const char * paymStr2,
                      long payment3, const char * paymStr3,
                      long change, const char * changeStr,
                      long pawn, const char * pawnStr,
                      const char * tableStr,
                      const char * custStr __MFPARAM );

/* 6.7. Zamkniecie zmiany */
MFBO_INT mfShiftEnd( __MFVPARAM );

/* 6.8. Wydruk linii paragonu aptecznego. */
MFBO_INT mfAptLineTicket( long no, const char *name, char taxCode,
                          const char *unitStr,
                          long price, long quantity, long value, long charge,
                          const char *payType, const char *recType, long refundation __MFPARAM );

/* 6.9. Rozszerzony wydruk linii */
MFBO_INT mfParLineTicketExt( __MFVPARAM );
MFBO_INT mfLineTicketExt( long no, const char *name, char taxCode,
                          const char *unitStr,
                          long price, long quantity, long value __MFPARAM );

/* 6.10. Rozszerzony wydruk linii */
MFBO_INT mfParStornoLineTicketExt( __MFVPARAM );
MFBO_INT mfStornoLineTicketExt( long no, const char *name, char taxCode,
                                const char *unitStr,
                                long price, long quantity, long value __MFPARAM );


/****************************************************************************/
/* 7. Funkcje obslugujace raporty fiskalne                                  */
/****************************************************************************/

/* 7.1. Rozpoczecie wydruku listy towarow danej stawki podatkowej */

/* a) SFI sprawdzajaca czy FP jest wykonalna */
MFBO_INT mfParPrBeTaxCode( __MFVPARAM );

/* b) FP rozpoczynajaca wydruk towarow z okreslonej stawki podatkowej */
MFBO_INT mfPrBeTaxCode( char taxCode __MFPARAM );


/* 7.2. Rozpoczecie wydruku listy towarow wedlug numeru porzadkowego */

/* a) SFI sprawdzajaca czy FP jest wykonalna */
MFBO_INT mfParPrBeItemNo( __MFVPARAM );

/* b)FP rozpoczynajaca wydruk towarow z okreslonego przedzialu kodow towarow*/
MFBO_INT mfPrBeItemNo( long *startItem, long *stopItem __MFPARAM );


/* 7.3. Wydruk pojedynczego towaru */
MFBO_INT mfPrItem( long no, const char *name, char taxCode __MFPARAM );

/* 7.4. Zakonczenie wydruku listy towarow */
MFBO_INT mfPrEnd( __MFVPARAM );

/* 7.5. Raport okresowy szczegolowy */
MFBO_INT mfPrDetailReport( int startYear, int startMonth, int startDay,
                           int stopYear,  int stopMonth,  int stopDay __MFPARAM );

/* 7.6. Raport okresowy sumaryczny */
MFBO_INT mfPrGlobalReport( int startYear, int startMonth, int startDay,
                           int stopYear,  int stopMonth,  int stopDay __MFPARAM );

/* 7.7. Wydruk stanu modulu fiskalnego */

/* a) SFI sprawdzajaca czy FP jest wykonalna */
MFBO_INT mfParPrState( __MFVPARAM );

/* b) FP drukujaca stan modulu fiskalnego */
MFBO_INT mfPrState( __MFVPARAM );


/* 7.8. Wydruk listy zmian towarow */

/* a) SFI sprawdzajaca czy FP jest wykonalna */
MFBO_INT mfParPrChangeItem( __MFVPARAM );

/* b) FP drukujaca wydruk listy zmian towarow */
MFBO_INT mfPrChangeItem( __MFVPARAM );


/****************************************************************************/
/* 8. Funkcje obslugujace paragon niefiskalny                               */
/****************************************************************************/

/* 8.1. Wydruk kwitu wplaty do kasy KP */

/* a) SFI okreslajaca czy skojarzona FP jest dostepna w danej DF */
MFBO_INT mfParPayIn( __MFVPARAM );

/* b) FP drukujaca dokument */
MFBO_INT mfPrPayIn( const char *no, const char *personName,
                    const char *payInName, const char *amount __MFPARAM );


/* 8.2. Wydruk kwitu wyplaty KW */

/* a) SFI okreslajaca czy skojarzona FP jest dostepna w danej DF */
MFBO_INT mfParPayOut( __MFVPARAM );

/* b) FP drukujaca dokument */
MFBO_INT mfPrPayOut( const char *no, const char *personName,
                     const char *payOutName, const char *amount __MFPARAM );

/* 8.3. Wydruk kwitu (bonu) zamowienia w kuchni */

/* a) SFI okreslajaca czy skojarzona FP jest dostepna w danej DF */
MFBO_INT mfParOrder( __MFVPARAM );

/* b) FP rozpoczynajaca wydruk */
MFBO_INT mfBgOrder( const char *title, const char *name __MFPARAM );

/* c) FP drukujaca jedna linie dokumentu */
MFBO_INT mfLineOrder( const char *name, const char *modifier, const char *quant __MFPARAM );

/* d) FP konczaca wydruk */
MFBO_INT mfEndOrder( __MFVPARAM );


/* 8.4. Wydruk dokumentu zwrotu towarow */

/* a) SFI okreslajaca czy skojarzona FP jest dostepna w danej DF */
MFBO_INT mfParReturn( __MFVPARAM );

/* b) FP rozpoczynajaca wydruk */
MFBO_INT mfBgReturn( const char *no, const char *personName, const char *value __MFPARAM );

/* c) FP drukujaca jedna linie dokumentu */
MFBO_INT mfLineReturn( const char *name, const char *quant, const char *total __MFPARAM );

/* d) FP konczaca wydruk */
MFBO_INT mfEndReturn( __MFVPARAM );


/* 8.5. Wydruk raportu rozliczenia kasjera */

/* a) SFI okreslajaca czy skojarzona FP jest dostepna w danej DF */
MFBO_INT mfParCashierReport( __MFVPARAM );

/* b) FP rozpoczynajaca wydruk */
MFBO_INT mfBgCashierReport( const char *no, const char *name __MFPARAM );

/* c) FP drukujaca jedna linie dokumentu */
MFBO_INT mfLineCashierReport( int typeNo,
                              const char *name, const char *counted,
                              const char *cash, const char *difference __MFPARAM );

/* d) FP konczaca wydruk */
MFBO_INT mfEndCashierReport( __MFVPARAM );


/* 8.6. Wydruk raportu rozliczenia zmiany */

/* a) SFI okreslajaca czy skojarzona FP jest dostepna w danej DF */
MFBO_INT mfParShiftReport( __MFVPARAM );

/* b) FP rozpoczynajaca wydruk */
MFBO_INT mfBgShiftReport( const char *no,
                          const char *startDate, const char *endDate,
                          const char *personName __MFPARAM );

/* c) FP drukujaca jedna linie dokumentu */
MFBO_INT mfLineShiftReport( int typeNo,
                            const char *name, const char *counted,
                            const char *cash, const char *difference __MFPARAM );

/* d) FP konczaca wydruk */
MFBO_INT mfEndShiftReport( __MFVPARAM );


/* 8.7. Uniewaznienie dokumentu */
MFBO_INT mfPrVoid( __MFVPARAM );

/* 8.8. Wydruk kwitu karty platniczej */
MFBO_INT mfParVISA( __MFVPARAM );

MFBO_INT mfPrVISA( int language,
                   int signature,
                   const char *date,
                   const char *transactionNo,
                   const char *ticketNo,
                   const char *salesPointNo,
                   const char *TID,
                   const char *UID,
                   const char *PosID,
                   const char *cashierName,
                   const char *cardName,
                   const char *cardNumber,
                   const char *expiryDate,
                   const char *authorizationCode,
                   const char *salesAmount,
                   const char *returnAmount,
                   const char *salesSays1,
                   const char *salesSays234 __MFPARAM );

MFBO_INT mfKasaWalutowa( const char *nrZezwolenia,
                         const char *regon,
                         const char *nrKwitu,
                         const char *skupWaluty,
                         const char *kursWaluty,
                         const char *kwotaWaluty,
                         const char *gotowka,
                         const char *reszta,
                         const char *wyplacono,
                         const char *kasjer __MFPARAM );

/****************************************************************************/
/* 9. Funkcje obslugujace szuflade                                          */
/****************************************************************************/

/* 9.1. Definicja parametrow (rodzaju) szuflady */

/* a) SFI zwracajaca nazwy zaimplementowanych szuflad */
MFBO_INT mfParDrawer( int item, char *name, int *maxNo __MFPARAM );

/* b) FP definiujaca typ szuflady */
MFBO_INT mfDefDrawer( int item, int portNo __MFPARAM );


/* 9.2. Otwarcie szuflady */
MFBO_INT mfDrawerOpen( int no __MFPARAM );

/* 9.3. Sprawdzenie stanu szuflady (otwarta/zamknieta) */
MFBO_INT mfDrawerIsOpen( int no, int *flag __MFPARAM );


/****************************************************************************/
/* 10. Funkcje obslugujace wyswietlacz                                      */
/****************************************************************************/

/* 10.1. Definicja parametrow (typow) wyswietlacza */

/* a) SFI zwracajaca parametry zaimplementowanych w danej wersji biblioteki */
/*   typow wyswietlaczy fiskalnych (dotyczy DF) lub niestandardowych        */
/*   (dotyczy DNF) */
MFBO_INT mfParFiscDisp( int item,
                        char *name,
                        int *column,
                        int *row,
                        char *setOfChar,
                        int *numericFlag,
                        int *pointFlag __MFPARAM );

/* b) FP definiujaca wyswietlacz dostepny z listy (fiskalny lub niestand. */
MFBO_INT mfDefFiscalDisp( int item, int portNo __MFPARAM );

/* c) FP definiujaca wyswietlacz niedostepny z listy (standardowy-niefisk/) */
MFBO_INT mfDefNFiscalDisp( int portNo,
                           int row, int column,
                           const char *setOfChar,
                           const char *begin0,
                           const char *begin1, const char *end1,
                           const char *begin2, const char *end2,
                           const char *begin3, const char *end3,
		                     int numericFlag, int pointFlag,
                           int sBounds, int sParity, int sHandshake,
		                     int codePage __MFPARAM );


/* 10.2. Wylaczenie/zalaczenie automatycznej obslugi wyswietlacza */
/* Funkcja usunieta */
/* MFBO_INT mfDispStop( int flag ); */

/* 10.3. Wyswietlenie POZYCJI SPRZEDAZY */
MFBO_INT mfDispTicketLine( const char *name,
                           long price, long quantity, long value __MFPARAM );

/* 10.4. Wyswietlenie SUMY */
MFBO_INT mfDispSum( const char *sumName, long sumValue __MFPARAM );

/* 10.5. Wyswietlenie PODSUMOWANIA */
MFBO_INT mfDispSummary( const char *payName, long payValue,
                        const char *remainderName, long remainderValue __MFPARAM );

/* 10.6. Wyswietlenie LOGO UZYTKOWNIKA */
MFBO_INT mfDispConsumerLOGO( const char *lineLOGO1, const char *lineLOGO2 __MFPARAM );


/****************************************************************************/
/* 11. Funkcje statusowe                                                    */
/****************************************************************************/

/* 11.1. Tryb szkoleniowy / fiskalny */
MFBO_INT mfStatMode( int *flag __MFPARAM );

/* 11.2. Waluta przed denominacja / po denominacji */
MFBO_INT mfStatDenom( int *flag __MFPARAM );

/* 11.3. Zmiana fiskalna zamknieta / otwarta. */
MFBO_INT mfStatShift( int *flag __MFPARAM );

/* 11.4. Paragon zamkniety / otwarty. */
MFBO_INT mfStatReceipt( int *flag __MFPARAM );

/* 11.5. Dokument nie drukowany / drukowany. */
MFBO_INT mfStatDocument( int *flag __MFPARAM );

/* 11.6. Brak papieru */
MFBO_INT mfStatNoPaper( int *flag __MFPARAM );


/****************************************************************************/
/* 12. Funkcje obslugujace apteczne paragony niefiskalne                    */
/****************************************************************************/

/* 12.1. Wycena leku */

//a)
MFBO_INT mfWycena1( int numerStacji,
                    const char *nazwa, const char *dawka,
                    const char *opakowanie, const char *unit,
                    long ilosc, long cena, long wartosc, long oplata,
                    const char *PTUstawka, long PTUwartosc __MFPARAM );

//b)
MFBO_INT mfWycena2( const char *iloscLekospisowa,
                    long limit, long ponadLimit,
                    long oplataPodstawowa, long doplata100, long refundacja,
                    const char *pacjent, const char *lekarz,
                    const char *refundator, const char *wojewodztwo __MFPARAM );

//c)
MFBO_INT mfWycena3( const char *platne, const char *recepta,
                    int refundacja, const char *wydal,
                    int kasa, long transakcja __MFPARAM );

//d)
MFBO_INT mfAnulujWycene( __MFVPARAM  );

/* 12.2. Wycena leku - kupon RUM */
// a)
MFBO_INT mfRUMStart( int numerStacji,
                     const char *recepta,
                     const char *kupon __MFPARAM );

// b)
MFBO_INT mfRUMLinia( const char *tekst,
                     const char *opakowanie,
                     const char *ilosc,
                     const char *cena,
                     const char *stawka,
                     const char *podatek,
                     const char *wartosc,
                     const char *platne,
                     const char *odplatnosc,
                     const char *refundacja,
                     const char *recepta __MFPARAM );

// c)
MFBO_INT mfRUMStop( const char *odplatnosc,
                    const char *refundacja,
                    const char *slownie,
                    const char *pacjent,
                    const char *lekarz,
                    const char *refundator,
                    const char *wojewodztwo,
                    const char *wydal,
                    const char *kasa __MFPARAM );

/* 12.3. Wycena leku robionego */
MFBO_INT mfLekStart( int numerStacji,
                     const char *recepta,
                     const char *odplatnosc,
                     const char *nrRecepty __MFPARAM );

MFBO_INT mfLekLinia( const char *nazwa,
                     const char *ilosc,
                     const char *wartosc __MFPARAM );

MFBO_INT mfLekStop( const char *wartoscBrutto,
                    const char *wartoscNetto,
                    const char *podatek,
                    const char *taksaLaborum,
                    const char *doZaplaty,
                    const char *starychZlotych,
                    const char *pacjent,
                    const char *lekarz,
                    const char *refundator,
                    const char *wojewodztwo,
                    const char *wydal,
                    const char *przyjal,
                    const char *wycenil,
                    const char *kasa,
                    const char *terminOdbioru,
                    const char *numerLeku __MFPARAM );

/* 12.4 Wydruk dowolnej linii */
MFBO_INT mfDrukuj( const char *formularz, const char *wiersz, const char *argument __MFPARAM );

/****************************************************************************/
/* 13. Funkcje obslugujace faktury                                          */
/****************************************************************************/

/* 13.1 Rozpoczecie faktury */
MFBO_INT mfFaktStart( int wysuw,
                      int typ, int napis,
		      int linii, int typRamki,
		      const char *nrFakt,
		      const char *nrOrg,
		      const char *miasto,
		      const char *dataWyst,
		      const char *dataSprz,
		      const char *nrParag,
		      const char *nrKasy,
		      const char *sprzedawca,
		      const char *sprzedawcaNIP,
		      const char *nabywca,
		      const char *nabywcaNIP,
		      const char *transport,
		      const char *bank,
		      const char *platnosc,
		      const char *termin,
		      long paperInTimeOut,
		      long paperOutTimeOut __MFPARAM );

/* 13.2 Wydruk linii faktury */
MFBO_INT mfFaktLinia( const char *nazwa,
		      const char *sww,
		      const char *jm,
		      const char *ilosc,
		      const char *cena,
		      const char *wartNetto,
		      const char *wartBrutto,
		      const char *stawka,
		      const char *wartPTU,
		      const char *wartOpl __MFPARAM );

/* 13.3 Zakonczenie faktury */
MFBO_INT mfFaktKoniec( const char *slownie,
                       const char *doZapl,
		       const char *nazwaSprz,
		       const char *nazwaOdb,
		       const char *dopiski,
		       const char *wartNettoA,
		       const char *wartBruttoA,
		       const char *stawkaA,
		       const char *wartPTUA,
		       const char *wartNettoB,
		       const char *wartBruttoB,
		       const char *stawkaB,
		       const char *wartPTUB,
		       const char *wartNettoC,
		       const char *wartBruttoC,
		       const char *stawkaC,
		       const char *wartPTUC,
		       const char *wartNettoD,
		       const char *wartBruttoD,
		       const char *stawkaD,
		       const char *wartPTUD,
		       const char *wartNettoE,
		       const char *wartBruttoE,
		       const char *stawkaE,
		       const char *wartPTUE,
		       const char *wartNettoF,
		       const char *wartBruttoF,
		       const char *stawkaF,
		       const char *wartPTUF,
		       const char *wartZwol,
		       const char *wartNettoSum,
		       const char *wartBruttoSum,
		       const char *wartPTUSum __MFPARAM );

/* 13.4 Anulacja faktury */
MFBO_INT mfAnulujFakture( __MFVPARAM );

/* 13.5 Stan czujnikow papieru */
MFBO_INT mfFaktPaper( int *paperIn, int *paperOut __MFPARAM );

/* Dodatek A - Komunikacja bezposrednia z DF */
MFBO_INT mfAnyCommand( int outputL, char *output, int inputL, char *input, int *resultL, long timeOut __MFPARAM );

/* Odczyt kodu bledu */
MFBO_INT mfError( __MFVPARAM );

/* Wydruk swobodny */
MFBO_INT mfStatFreePrintEnabled( __MFVPARAM );
MFBO_INT mfFreePrintInit( __MFVPARAM );
MFBO_INT mfFreePrintLine( const char * line __MFPARAM );
MFBO_INT mfFreePrintEnd( __MFVPARAM );
MFBO_INT mfFreePrintVoid( __MFVPARAM );

/* Wydruk dwuwalutowy;  exchange rate ma 4 miejsca po przecinku */
MFBO_INT mfSecondCurrency( const char * currencyName, long exchangeRate __MFPARAM );

/* Raport okresowy zmianowy wg numerow zmian */
MFBO_INT mfParNrReport( __MFVPARAM );
MFBO_INT mfPrNrReport( long startNr, long stopNr __MFPARAM );

/* Wysuw papieru */
MFBO_INT mfParFeedLine( __MFVPARAM );
MFBO_INT mfFeedLine( int nrOfLines __MFPARAM );



#ifdef __cplusplus
}
#endif


#endif /* __MFBO_H */
