#include "extend.h"

/******************************  kody bledow  *******************************/
#define mfeOk          0x0000  /* Wykonanie poprawne */

#define mfeImplementation 1
#define mfeApplication  (-1)
#define mfeFunction     (-2)
#define mfeAssociation  (-3)
#define mfeAccess       (-4)

#define mfeOk          0x0000 /* Wykonanie poprawne */
#define mfeHardware    0x0101 /* Bd sprztowy wewntrz czci fiskalnej */
#define mfeReserves1   0x0102 /* Wyczerpane zasoby nieodzyskiwalne */
#define mfeInitialize1 0x0103 /* Modu niezainicjowany */

#define mfeDisplay     0x0201 /* Brak komunikacji z wywietlaczem */
#define mfePrinter     0x0202 /* Bd komunikacji z drukark */
#define mfeBattery     0x0203 /* Niskie napicie baterii */
#define mfeReserves2   0x0204 /* Wyczerpane zasoby odzyskiwalne */
#define mfeFirmware    0x0205 /* Bd sprztowy wewntrz czci niefiskalnej */
#define mfeInitialize2 0x0206 /* Modu fiskalny nie zainicjowany przez serwisanta */

#define mfeAnyError     0x0301 /* Inny bd */
#define mfeNesting      0x0302 /* Niedopuszczalne zagniedenie funkcji */
#define mfeOutOfRange   0x0303 /* Przekroczenie zakresu */
#define mfeBadTaxRate   0x0304 /* Za stawka podatkowa */
#define mfeBadSellName  0x0305 /* Towar o podanej nazwie nie moe by sprzedany */
#define mfeBadDefName   0x0306 /* Towar o podanej nazwie nie moe by zdefiniowany */
#define mfeNoClkChng    0x0307 /* Przestawienie zegara niemoliwe */
#define mfeReserve2     0x0308 /* */
#define mfeShiftOpen    0x0309 /* Zmiana otwarta */
#define mfeShiftClose   0x030A /* Zmiana zamknita */
#define mfeReceiptOpen  0x030B /* Paragon w druku */
#define mfeReceiptClose 0x030C /* Paragon nie jest w druku */
#define mfeNoMoreShift  0x030D /* Limit zmian wyczerpany */
#define mfeInvFormat    0x030E /* Brak denominacji */
#define mfeHDDErr       0x030F /* Bd komunikacji z dyskiem */
#define mfeOutOfPaper   0x0310 /* Brak papieru */


// 2. funkcje informacyjne.

// 2.1. Odczyt czasu zegara wewnetrznego MF.
// int mfGetTime( int* hour, int* minute );
CLIPPER cfGetTime (void);
  // Parameters
  //   NUMERIC     *hour
  //   NUMERIC     *minute
  // return NUMERIC

// 2.2. Odczyt daty zegara wewnetrznego MF.
// int mfGetDate( int* year, int* month, int* day );
CLIPPER cfGetDate (void);
  // parameters
  //   NUMERIC    *year
  //   NUMERIC    *month
  //   NUMERIC    *day
  // return NUMERIC

// 2.3. Odczyt wersji MF.
// int mfGetVer( int* version, int* subVersion );
CLIPPER cfGetVersi(void);
  // parameters
  //   NUMERIC    *version
  //   NUMERIC    *subVerion
  // return NUMERIC

// 2.4. Wspolczynnik wolnych zasobow.
// int mfGetCoefficient( int* recCoefficient, int* unRecCoefficient );
CLIPPER cfGetCoefficient (void);
  // parameters
  //   NUMERIC     *recCoefficient;
  //   NUMERIC     *unRecCoefficient;
  // return NUMERIC

// 2.5. Odczyt numeru ostatniego paragonu.
// int mfGetLastTicketNo( long* lastTicketNo );
CLIPPER cfGetLastTicketNo(void);
  // parameters
  //   NUMERIC    *lastTicketNo
  // return NUMERIC

// 2.6. Odczyt stawek podatkowych.
// int mfGetTax( int* taxA, int* taxB, int* taxC, int* taxD, int* taxE, int* taxF );
CLIPPER cfGetTaxRate(void);
  // parameters
  //   NUMERIC    *taxA
  //   NUMERIC    *taxB
  //   NUMERIC    *taxC
  //   NUMERIC    *taxD
  //   NUMERIC    *taxE
  //   NUMERIC    *taxF
  // return NUMERIC

/*********************************************************************/

// 3. Funkcje pomocnicze.

// 3.1. Odczyt maksymalniej liczby zmian w ciagu doby.
// int mfParMaxShiftNo( int* maxShiftNo );
CLIPPER cfParMaxShiftNo (void);
  // parameters
  //   NUMERIC   * maxShiftNo
  // return NUMERIC

// 3.2. Odczyt rodzaju biblioteki (niefiskalna/fiskalna);.
// int mfParFiscal( int* flag );
CLIPPER cfParFiscal (void);
  // parameters
  //   NUMERIC    *flag
  // return NUMERIC

// 3.3. Odczyt wersji biblioteki.
// int mfParLibVersion( int* version, int* subVersion );
CLIPPER cfParLibVersion (void);
  // parameters
  //   NUMERIC    *version
  //   NUMERIC    *subVersion
  // return NUMERIC

// 3.4. Odczyt tresci komunikatu.
// int mfParMessage( int code, char* groupMsg, char* detailMsg );
CLIPPER cfParMessage (void);
  // parameters
  //   NUMERIC      code
  //   CHARACTER   *groupMsg
  //   CHARACTER   *detailMsg
  // return NUMERIC

// 3.5. Odczyt parametrow danych o towarze.
// int mfParPLU( long* maxCode, int* length, char* setOfChar );
CLIPPER cfParPLU (void);
  //  parameters
  //    NUMERIC     *maxCode
  //    NUMERIC     *length
  //    CHARACTER   *setOfChar
  //  return NUMERIC

// 3.6. Odczyt parametrow dotyczacych formatu naglowka na paragonach.
// int mfParHeader ( int* flag, int* maxLines, int* length, char* setOfChar );
CLIPPER cfParHeader ( void );
  //  parameters
  //    NUMERIC    *flag
  //    NUMERIC    *maxLines
  //    NUMERIC    *length
  //    CHARACTER  *setOfChar
  //  return NUMERIC

// 3.7. Odczyt danych dotyczacych parametrow wydruku paragonu
// int mfParTicket ( int* discountDecimalPoint, int* flag );
CLIPPER cfParTicket ( void );
  //  parameters
  //    NUMERIC    *discountDecimalPoint
  //    NUMERIC    *flag
  //  return NUMERIC

/*********************************************************************/

// 4. Funkcje inicjujace, ustawiajace i definiujace.

// 4.1. Dopuszczenie aplikacji.
// int mfStart( char* ident, int mfPortType, int mfPortNo,
//              int column, int emptyLine, char* endLine, char* cutPaper,
//              int taxA, int taxB, int taxC, int taxD,
//              int sBouds, int sParity, int sStopBits,
//              int codePage, char* inithString  );
CLIPPER cfStart ( void );
  // parameters
  //   CHARACTER    *ident
  //   NUMERIC       mfPortType
  //   NUMERIC       mfPortNo
  //   NUMERIC       column
  //   NUMERIC       emptyLine
  //   CHARACTER    *endLine
  //   CHARACTER    *cutPaper
  //   NUMERIC       taxA, taxB, taxC, taxD
  //   NUMERIC       cBouds, sParity, sStopBits
  //   NUMERIC       codePage
  //   CHARACTER    *inithString
  // return NUMERIC

// 4.2. Definicja stopki paragonu.
// int mfParFooter( int* maxLines, int* length, char* setOfChar );
CLIPPER cfParFooter ( void );
  // parameters
  //   NUMERIC        *maxLines
  //   NUMERIC        *length
  //   CHARACTER      *setOfChar
  // return NUMERIC

// b); FP definiujaca stopke
// int mfDefFooter( char* footer );
CLIPPER cfDefFooter ( void );
  // parameters
  //   CHARACTER   * footer
  // return NUMERIC

// 4.3. Definicja numeru kasy i kasjera oraz nazwy kasjera
// int mfParPOS( int* maxCashNo, int* maxCashierNo,
//               int* lengthName, char* setOfChar );
CLIPPER cfParPOS ( void );
  // parameters
  //   NUMERIC      *maxCashNo
  //   NUMERIC      *maxCashierNo
  //   NUMERIC      *lengthName
  //   CHARACTER    *setOfChar
  // return NUMERIC

// b); FP definiujaca kasy i kasjera oraz nazwe kasjera
// FP definiujaca numer kasy i kasjera oraz nazwe kasjera
// int mfDefPOS ( int cashNo, int cashierNo, char* cashierName );
CLIPPER cfDefPOS ( void );
  //  parameters
  //    NUMERIC      cashNo
  //    NUMERIC      cashierNo
  //    CHARACTER   *cashierName
  //  return NUMERIC

// 4.4. Ustawienie czasu zegara wewnetrznego MF.
// int mfParTime( void );
CLIPPER cfParTime ( void );
  // parameters
  //   none
  // return NUMERIC

// int mfDefTime( int hour, int minute );
CLIPPER cfDefTime ( void );
  // parameters
  //   NUMERIC hour
  //   NUMERIC minute
  // return NUMERIC

// 4.5. Ustawienie wewnetrznego licznika paragonow MF.
// int mfParCounter ( void );
CLIPPER cfParCounter ( void );
  // parameters
  //   none
	// return NUMERIC

// b);
// int mfDefCounter( long* counter );
CLIPPER cfDefCounter ( void );
  // parameters
  //   NUMERIC    *counter
  // return NUMERIC


/*********************************************************************/

// 5. Funkcje towarowe.


// 5.1.SFI zwracajace informacje o mozliwosci zaktualizowania bazy towarowej

// a) SFI zwracajaca informacje o mozliwosci czesciowego zaktualizowania
//    bazy towarowej
// int mfParDefPLU( void );
CLIPPER cfParDefPLU ( void );
  //  parameters
  //    none
  //  return NUMERIC

// b) SFI zwracajaca informacje o mozliwosci calkowitego zaktualizowania
//      bazy towarowej
// int mfParDefAllPLU( void );
CLIPPER cfParDefAllPLU ( void );
  //  parameters
  //    none
  //  return NUMERIC

// 5.2. Rozpoczecie calkowitego ladowania towarow.
// int mfBeDefPLU( void );
CLIPPER cfBeDefPLU (void);
  // parameters
  //   none
  // return NUMERIC

// 5.3. Rozpoczecie calkowitego ladowania towarow
// int mfBeDefAllPLU ( void );
CLIPPER cfBeDefAllPLU ( void );
  //  parameters
  //    none
  //  return NUMERIC

// 5.4. Zaladowanie jednego towaru.
// int mfDefPLU( long no, char* name, char taxCode );
CLIPPER cfDefPLU (void);
  // parameters
  //   NUMERIC      no
  //   CHARACTER   *name
  //   CHARACTER    taxCode
  // return NUMERIC

// 5.5. Zakonczenie ladowania towarow.
// int mfEndDefPLU( void );
CLIPPER cfEndDefPLU (void);
  // parameters
  //   none
  // return NUMERIC

/*********************************************************************/

// 6. Funkcje obslugujace paragon fiskalny.

// 6.1. Rozpoczecie doby fiskalnej.
// int mfBeginShift( char* header );
CLIPPER cfBeginShift ( void );
  // parameters
  //   CHARACTER    *header
  // return NUMERIC

// 6.2. Rozpoczecie wydruku paragonu.
// int mfBeginTicket( void );
CLIPPER cfBeginTicket (void);
  // parameters
  //   NUMERIC      total
  // return NUMERIC


// 6.3. Wydruk linii paragonu.
// int mfLineTicket( long no, char* name, char taxCode,
//                   char* unitStr, long price, long quantity, long value );
CLIPPER cfLineTicket (void);
  // parameters
  //   NUMERIC        no
  //   CHARACTER     *name
  //   CHARACTER      taxCode
  //   CHARACTER     *unitStr
  //   NUMERIC        price
  //   NUMERIC        quantity
  //   NUMERIC        value
  // return NUMERIC

// 6.4. Uniewaznienie linii paragonu.
// int mfStornoLineTicket( long No, char* Name, char TaxCode,
//                         char* unitStr, long Price, long Quantity, long Value );
CLIPPER cfStornoLineTicket (void);
  // parameters
  //   NUMERIC        no
  //   CHARACTER     *name
  //   CHARACTER      taxCode
  //   CHARACTER     *unitStr
  //   NUMERIC        price
  //   NUMERIC        quantity
  //   NUMERIC        value
  // return NUMERIC

// 6.5. Uniewaznienie paragonu.
// int mfStornoTicket( void );
CLIPPER cfStornoTicket (void);
  // parameters
  //   none
  // return NUMERIC

// 6.6. Zakonczenie wydruku paragonu
// int mfEndTicket( int percentDiscount, long valueDiscount,
//                  long transactionNo,
//                  long payment1, const char * paymStr1,
//                  long payment2, const char * paymStr2,
//                  long payment3, const char * paymStr3,
//                  long change, const char * changeStr,
//                  long pawn, const char * pawnStr,
//                  const char * tableStr,
//                  const char * custStr );
CLIPPER cfEndTicket ( void );
  //  parameters
  //    NUMERIC    percentDiscount
  //    NUMERIC    valueDiscount
  //    NUMERIC    transactionNo
  //    NUMERIC    payment1
  //    CHARACTER  paymStr1
  //    NUMERIC    payment2
  //    CHARACTER  paymStr2
  //    NUMERIC    payment3
  //    CHARACTER  paymStr3
  //    NUMERIC    change
  //    CHARACTER  changeStr
  //    NUMERIC    pawn
  //    CHARACTER  pawnStr
  //    CHARACTER  tableStr
  //    CHARACTER  custStr
  //  return NUMERIC

// 6.7. Zamkniecie zmiany.
// int mfShiftEnd ( void );
CLIPPER cfShiftEnd ( void );
  //  parameters
  //    none
  //  return NUMERIC

// 6.8. Wydruk linii paragonu aptecznego.
// int mfAptLineTicket( long no, const char *name, char taxCode,
//                      const char *unit,
//                      long price, long quantity, long value, long charge,
//                      const char *payType, const char *recType, long refundation );
CLIPPER cfAptLineTicket ( void );
  //  parameters
  //    NUMERIC        no
  //    CHARACTER     *name
  //    CHARACTER      taxCode
  //    CHARACTER     *unit
  //    NUMERIC        price
  //    NUMERIC        quantity
  //    NUMERIC        value
  //    NUMERIC        charge
  //    CHARACTER     *payType
  //    CHARACTER     *recType
  //    NUMERIC        refundation
  //  return NUMERIC

/*********************************************************************/

// 7. Funkcje obslugujace raporty fiskalne.

// 7.1. Rozpoczecie wydruku listy towarow danej stawki podatkowej.
// a); SFI sprawdzajaca czy FP jest wykonalna
// int mfParPrBeTaxCode( void );
CLIPPER cfParPrBeTaxCode (void);
  // parameters
  //   none
  // return NUMERIC

// b); FP rozpoczynajaca wydruk towarow z okreslonej stawki podatkowej
// int mfPrBeTaxCode( char taxCode );
CLIPPER cfPrBeTaxCode (void);
  // parameters
  //   CHARACTER     taxCode
  // return NUMERIC

// 7.2. Rozpoczecie wydruku listy towarow wedlug numeru porzadkowego.
// int mfParPrBeItemNo( void );
CLIPPER cfParPrBeItemNo (void);
  // parameters
  //   none
  // return NUMERIC

// b); FP rozpoczynajaca wydruk towarow z okreslonego przedzialu kodow towarow
// int mfPrBeItemNo( long startItem, long* stopItem );
CLIPPER cfPrBeItemNo (void);
  // parameters
  //   NUMERIC   *startItem
  //   NUMERIC   *stopItem
  // return NUMERIC

// 7.3. Wydruk pojedynczego towaru.
// int mfPrItem( long no, char* name, char taxCode );
CLIPPER cfPrItem (void);
  // parameters
  //   NUMERIC      no
  //   CHARACTER   *name
  //   CHARACTER    taxCode
  // return NUMERIC

// 7.4. Zakonczenie wydruku listy towarow.
// int mfPrEnd( void );
CLIPPER cfPrEnd (void);
  // parameters
  //   none
  // return NUMERIC

// 7.5.  Raport okresowy szczegolowy
// int mfPrDetailReport( int startYear, int startMonth, int startDay,
//                          int stopYear,  int stopMonth,  int stopDay );
CLIPPER cfPrDetailReport (void);
  // parameters
  //   NUMERIC   startYear
  //   NUMERIC   startMonth
  //   NUMERIC   startDay
  //   NUMERIC   stopYear
  //   NUMERIC   stopMonth
  //   NUMERIC   stopDay
  // return NUMERIC

// 7.6. Raport okresowy sumaryczny.
// int mfPrGlobalReport( int startYear, int startMonth, int startDay,
//                       int stopYear,  int stopMonth,  int stopDay );
CLIPPER cfPrGlobalReport (void);
  // parameters
  //   NUMERIC   startYear
  //   NUMERIC   startMonth
  //   NUMERIC   startDay
  //   NUMERIC   stopYear
  //   NUMERIC   stopMonth
  //   NUMERIC   stopDay
  // return NUMERIC

// 7.7. Wydruk stanu modulu fiskalnego.
// int mfParPrState( void );
CLIPPER cfParPrState (void);
  // parameters
  //   none
  // return NUMERIC

// b); FP drukujaca stan modulu fiskalnego
// int mfPrState( void );
CLIPPER cfPrState (void);
  // parameters
  //   none
  // return NUMERIC

// 7.8. SFI sprawdzajaca cz FP jest wykonywalna
// int mfParPrChangeItem ( void );
CLIPPER cfParPrChangeItem ( void );
  //  parameters
  //    none
  //  return NUMERIC

//
// b); FP drukujaca wydruk listy zmian towarow
// int mfPrChangeItem ( void );
CLIPPER cfPrChangeItem ( void );
  //  parameters
  //    none
  //  return NUMERIC

/*********************************************************************/
// 8. Funkcje obsugujce paragon fiskalny

// 8.1. Wydruk kwitu wplaty do kasy KP
// a); SFI okreslajaca czy skojarzona FP jest dostepna w danej DF
// int mfParPayIn ( void );
CLIPPER cfParPayIn ( void );
  // parameters
  //   none
  // return NUMERIC

// b); FP drukujaca dokument
// int mfPrPayIn ( char* no, char* personName, char* payInName, char* amount);
CLIPPER cfPrPayIn ( void );
  // parameters
  //   CHARACTER    *no
  //   CHARACTER    *personName
  //   CHARACTER    *payInName
  //   CHARACTER    *amount
  // return NUMERIC

// 8.2. Wydruk kwitu wyplaty z kasy KW
// a); SFI okreslajaca czy skojarzona FP jest dostepna w danej DF
// int mfParPayOut ( void );
CLIPPER cfParPayOut ( void );
  // parameters
  //   none
  // return NUMERIC

// b); FP drukujaca dokument
// int mfPrPayOut ( char* no, char* personName, char* payInName, char* amount);
CLIPPER cfPrPayOut ( void );
  // parameters
  //   CHARACTER   *no
  //   CHARACTER   *personName
  //   CHARACTER   *payInName
  //   CHARACTER   *amount
  // return NUMERIC


// 8.3. Wydruk kwitu (bonu); zamowienia w kuchni
// a); SFI okreslajaca czy skojarzona FP jest dostepna w danej DF
// int mfParOrder ( void );
CLIPPER cfParOrder ( void );
  // parameters
  //   none
  // return NUMERIC

// b); FP rozpoczynajaca wydruk
// int mfBgOrder ( char* title, char* name );
CLIPPER cfBgOrder ( void );
  // parameters
  //   CHARACTER   *title
  //   CHARACTER   *name
  // return NUMERIC

// c); FP drukujaca jedna linie dokumentu
// int mfLineOrder ( char* name, char* modified, char* quant );
CLIPPER cfLineOrder ( void );
  // parameters
  //   CHARACTER   *name
  //   CHARACTER   *modified
  //   CHARACTER   *quant
  // return NUMERIC

// d); FP konczaca wydruk
// int mfEndOrder ( void );
CLIPPER cfEndOrder ( void );
  // parameters
  //   none
  // return NUMERIC

// 8.4. Wydruk dokumentu zwrotu towarow
// a); SF okreslajaca czy skojarzona FP jest dostepna w danej DF
// int mfParReturn ( void );
CLIPPER cfParReturn ( void );
  // parameters
  //   none
  // return NUMERIC

// b); FP rozpoczynajaca wydruk
// int mfBgReturn ( char* no, char* personName, char* value );
CLIPPER cfBgReturn ( void );
  // parameters
  //   CHARACTER     *no
  //   CHARACTER     *personName
  //   CHARACTER     *value
  // return NUMERIC

// c); FP drukujaca jedna linie dokumentu
// int mfLineReturn ( char* name, char* quant, char* total );
CLIPPER cfLineReturn ( void );
  // parameters
  //   CHARACTER    *name
  //   CHARACTER    *quant
  //   CHARACTER    *total
  // return NUMERIC

// d); FP konczaca wydruk
// int mfEndReturn ( void );
CLIPPER cfEndReturn ( void );
  // parameters
  //   none
  // return NUMERIC

// 8.5. Wydruk raportu rozliczenia kasjera
// a); SFI okreslajaca czy skojarzona FP jest dostepna w danej DF
// int mfParCashierReport ( void );
CLIPPER cfParCashierReport ( void );
  // parameters
  //   none
  // return NUMERIC

// b); FP rozpoczynajaca wydruk
// int mfBgCashierReport ( char* no, char* name );
CLIPPER cfBgCashierReport ( void );
  // parameters
  //   CHARACTER   *no
  //   CHARACTER   *name
  // return NUMERIC

// c); FP drukujaca jedna linie dokumentu
// int mfLineCashierReport(int typeNo, char* name, char* counted,
//                         char* cash, char* difference);
CLIPPER cfLineCashierReport ( void );
  // parameters
  //   NUMERIC      typeNo
  //   CHARACTER   *name
  //   CHARACTER   *counted
  //   CHARACTER   *cash
  //   CHARACTER   *difference
  // return NUMERIC

// d); FP konczaca wydruk
// int mfEndCashierReport ( void );
CLIPPER cfEndCashierReport ( void );
  // parameters
  //   none
  // return NUMERIC

// 8.6. Wydruk niefiskalnego raportu konca zmiany
// a); SFI okreslajaca czy skojarzona FP jest dostepna w danej DF
// int mfParShiftReport ( void );
CLIPPER cfParShiftReport ( void );
  // parameters
  //   none
  // return NUMERIC

// b); FP rozpoczynajaca wydruk
// int mfBgShiftReport ( char* no, char* startDate, char* endDate );
CLIPPER cfBgShiftReport ( void );
  // parameters
  //   CHARACTER   *no
  //   CHARACTER   *startDate
  //   CHARACTER   *endDate
  //   CHARACTER   *personName
  // return NUMERIC

// c); FP drukujaca jedna linie dokumentu
// int mfLineShiftReport (int typeNo, char* name, char* counted,
//                        char* cash, char* difference);
CLIPPER cfLineShiftReport ( void );
  // parameters
  //   NUMERIC      typeNo
  //   CHARACTER   *name
  //   CHARACTER   *counted
  //   CHARACTER   *cash
  //   CHARACTER   *difference
  // return NUMERIC

// d); FP konczaca wydruk
// int mfEndShiftReport ( void );
CLIPPER cfEndShiftReport ( void );
  // parameters
  //   none
  // return NUMERIC

// 8.7. Uniewaznienie dokumentu
// int mfPrVoid ( void );
CLIPPER cfPrVoid ( void );
  // parameters
  //   none
  // return NUMERIC
/*********************************************************************/
// 9. Funkcje obslugujace szuflade.

// 9.1. Definicja parametrow (rodzaju); szuflady.
// int mfParDrawer( int item, char* name, int* maxNo );
CLIPPER cfParDrawer (void);
  // parameters
  //   NUMERIC      item
  //   CHARACTER   *name
  //   NUMERIC     *maxNo
  // return NUMERIC

// b); FP definiujaca typ szyflady
// int mfDefDrawer( int item, int portNo );
CLIPPER cfDefDrawer ( void );
  // parameters
  //   NUMERIC    item
  //   NUMERIC    portNo
  // return NUMERIC

// 9.2. Otwarcie szuflady.
// int mfDrawerOpen( int no );
CLIPPER cfDrawerOpen ( void );
  // parameters
  //   NUMERIC     no
  // return NUMERIC

// 9.3. Sprawdzenie stanu szuflady.
// int mfDrawerIsOpen( int no, int* flag );
CLIPPER cfDrawerIsOpen (void);
  // parameters
  //   NUMERIC    no
  //   NUMERIC   *flag
  // return NUMERIC

/*********************************************************************/

// 10. Funkcje obslugujace wyswietlacz.

// 10.1. Definicja parametrow wyswietlacza.
// int mfParFiscDisp( int item, char* name,
//                    int* column, int* row, char* setOfChar,
//                    int* numericFlag,
//                    int* pointFlag );
CLIPPER cfParFiscDisp (void);
  // parameters
  //   NUMERIC      item
  //   CHARACTER   *name
  //   NUMERIC     *column
  //   NUMERIC     *row
  //   CHARACTER   *setOfChar
  //   NUMERIC     *numericFlag
  //   NUMERIC     *pointFlag
  // return NUMERIC

// b); FP definiujaca wyswietalcz dostepny z listy ( fiskalny lub niestandardowy );
// int mfDefFiscalDisp( int item, int portNo );
CLIPPER cfDefSetFiscalDisp (void);
  // parameters
  //   NUMERIC   item
  //   NUMERIC   portNo
  // return NUMERIC


// 10.3. Wyswietlenie POZYCJI SPRZEDAZY.
// int mfDispTicketLine( char* Name, long Price, long Quantity, long Value );
CLIPPER cfDispTicketLine (void);
  // parameters
  //   CHARACTER     *Name
  //   NUMERIC        Price
  //   NUMERIC        Quantity
  //   NUMERIC        Value
  // return NUMERIC

// 10.4. Wyswietlenie SUMY.
// int mfDispSum( char* SumName, long SumValue );
CLIPPER cfDispSum (void);
  // parameters
  //   CHARACTER     *sumName
  //   NUMERIC        sumValue
  // return NUMERIC

// 10.5. Wyswietlenie PODSUMOWANIA.
// int mfDispSummary( char* payName,       long payValue,
//                    char* remainderName, long remainderValue );
CLIPPER cfDispSummary (void);
  // parameters
  //   CHARACTER     *payName
  //   NUMERIC        payValue
  //   CHARACTER     *remainderName
  //   NUMERIC        remainderValue
  // return NUMERIC

// 10.6. Wyswietlenie LOGO UZYTKOWNIKA.
// int mfDispConsumerLOGO( char* lineLOGO1, char* LineLOGO2 );
CLIPPER cfDispConsumerLOGO (void);
  // parameters
  //   CHARACTER   *lineLOGO1
  //   CHARACTER   *lineLOGO2
  // return NUMERIC

/*********************************************************************/

// 11. Funkcje statusowe.

// 11.1. Tryb szkoleniowy / fiskalny.
// int mfStatMode( int* flag );
CLIPPER cfStatMode (void);
  // parameters
  //   NUMERIC    *flag
  // return NUMERIC

// 11.2. Waluta przed denominacja / po denominacji
// int mfStatDenom ( int* flag );
CLIPPER cfStatDenom ( void );
  //  parameters
  //    NUMERIC    *flag
  //  return NUMERIC

// 11.3. Zmiana zamknieta / otwarta.
// int mfStatShift( int* flag );
CLIPPER cfStatShift (void);
  //  parameters
  //    NUMERIC   *flag
  //  return NUMERIC

// 11.4. Paragon zamkniety / otwarty.
// int mfStatReceipt( int* flag );
CLIPPER cfStatRecept (void);
  // parameters
  //   NUMERIC     *flag
  // return NUMERIC

// 11.5. Dokument nie drukowany / drukowany.
// int mfStatDocument( int* flag );
CLIPPER cfStatDocument (void);
  // parameters
  //   NUMERIC   * flag
  // return NUMERIC

// 11.6. Brak papieru
// int mfStatNoPaper( int *flag );
CLIPPER cfStatNoPaper (void);
  // parameters
  //   NUMERIC   * flag
  // return NUMERIC

/*********************************************************************/

// 12. Funkcje obslugujace apteczne paragony niefiskalne

// 12.1. Wycena leku
// a)
// int mfWycena1( int numerStacji,
//                const char *nazwa, const char *dawka, const char *opakowanie,
//                long ilosc, long cena, long wartosc, long oplata,
//                const char *PTUstawka, long PTUwartosc );
CLIPPER cfWycena1 (void);
  // parameters
  //   NUMERIC     numerStacji
  //   CHARACTER  *nazwa
  //   CHARACTER  *dawka
  //   CHARACTER  *opakowanie
  //   NUMERIC     ilosc
  //   NUMERIC     cena
  //   NUMERIC     wartosc
  //   NUMERIC     oplata
  //   CHARACTER   PTUstawka
  //   NUMERIC     PTUwartosc
  // return NUMERIC

// b)
// int mfWycena2( const char *iloscLekospisowa, long limit, long ponadLimit,
//                long oplataPodstawowa, long doplata100, long refundacja,
//                const char *pacjent, const char *lekarz,
//                const char *refundator, const char *wojewodztwo );
CLIPPER cfWycena2 (void);
  // parameters
  //   CHARACTER   iloscLekospisowa
  //   NUMERIC     limit
  //   NUMERIC     ponadLimit
  //   NUMERIC     oplataPodstawowa
  //   NUMERIC     doplata100
  //   NUMERIC     refundacja
  //   CHARACTER  *pacjent
  //   CHARACTER  *lekarz
  //   CHARACTER  *refundator
  //   CHARACTER  *wojewodztwo
  // return NUMERIC

// c)
// int mfWycena3( const char *platne, const char *recepta,
//                int refundacja, const char *wydal,
//                int kasa, long transakcja );
CLIPPER cfWycena3 (void);
  // parameters
  //   CHARACTER  *platne
  //   CHARACTER  *recepta
  //   NUMERIC     refundacja
  //   CHARACTER  *wydal
  //   NUMERIC     kasa
  //   NUMERIC     transakcja
  // return NUMERIC

//d)
CLIPPER cfAnulujWy (void);

// 12.2. Wycena leku - kupon RUM
// a)
// int mfRUMStart( int numerStacji,
//                 const char *recepta,
//                 const char *kupon );
CLIPPER cfRUMStart(void);

// b)
// int mfRUMLinia( const char *tekst,
//                 const char *opakowanie,
//                 const char *ilosc,
//                 const char *cena,
//                 const char *stawka,
//                 const char *podatek,
//                 const char *wartosc,
//                 const char *platne,
//                 const char *odplatnosc,
//                 const char *refundacja,
//                 const char *recepta );
CLIPPER cfRUMLinia(void);

// c)
// int mfRUMStop( const char *odplatnosc,
//                 const char *refundacja,
//                 const char *slownie,
//                 const char *pacjent,
//                 const char *lekarz,
//                 const char *refundator,
//                 const char *wojewodztwo,
//                 const char *wydal,
//                 const char *kasa );
CLIPPER cfRUMStop(void);

// 12.3. Wycena leku robionego
// int mfLekStart( int numerStacji,
//                 const char *recepta,
//                 const char *odplatnosc,
//                 const char *nrRecepty );
CLIPPER cfLekStart(void);

// int mfLekLinia( const char *nazwa,
//                 const char *ilosc,
//                 const char *wartosc );
CLIPPER cfLekinia(void);

// int mfLekStop( const char *wartoscBrutto,
//                const char *wartoscNetto,
//                const char *podatek,
//                const char *taksaLaborum,
//                const char *doZaplaty,
//                const char *starychZlotych,
//                const char *pacjent,
//                const char *lekarz,
//                const char *refundator,
//                const char *wojewodztwo,
//                const char *wydal,
//                const char *przyjal,
//                const char *wycenil,
//                const char *kasa,
//                const char *terminOdbioru,
//                const char *numerLeku );
CLIPPER cfLekStop(void);

// 12.4 Wydruk dowolnej linii
// int mfDrukuj( const char *formularz, const char *wiersz, const char *argument );
CLIPPER cfDrukuj (void);


/*********************************************************************/

// 13. Funkcje obslugujace faktury

// 13.1 Rozpoczecie faktury
// int mfFaktStart( int wysuw,
//                  int typ, int napis,
//                  int linii, int typRamki,
//                  const char *nrFakt,
//                  const char *nrOrg,
//                  const char *miasto,
//                  const char *dataWyst,
//                  const char *dataSprz,
//                  const char *nrParag,
//                  const char *nrKasy,
//                  const char *sprzedawca,
//                  const char *sprzedawcaNIP,
//                  const char *nabywca,
//                  const char *nabywcaNIP,
//                  const char *transport,
//                  const char *bank,
//                  const char *platnosc,
//                  const char *termin,
//      		    long paperInTimeOut,
//		            long paperOutTimeOut );
CLIPPER cfFaktStar (void);

// 13.2 Wydruk linii faktury
// int mfFaktLinia( const char *nazwa,
//                  const char *sww,
//                  const char *jm,
//                  const char *ilosc,
//                  const char *cena,
//                  const char *wartNetto,
//                  const char *wartBrutto,
//                  const char *stawka,
//                  const char *wartPTU,
//                  const char *wartOpl );
CLIPPER cfFaktLini (void);

// 13.3 Zakonczenie faktury
// int mfFaktKoniec( const char *slownie,
//                   const char *doZapl,
//                   const char *nazwaSprz,
//                   const char *nazwaOdb,
//                   const char *dopiski,
//                   const char *wartNettoA,
//                   const char *wartBruttoA,
//                   const char *stawkaA,
//                   const char *wartPTUA,
//                   const char *wartNettoB,
//                   const char *wartBruttoB,
//                   const char *stawkaB,
//                   const char *wartPTUB,
//                   const char *wartNettoC,
//                   const char *wartBruttoC,
//                   const char *stawkaC,
//                   const char *wartPTUC,
//                   const char *wartNettoD,
//                   const char *wartBruttoD,
//                   const char *stawkaD,
//                   const char *wartPTUD,
//                   const char *wartNettoE,
//                   const char *wartBruttoE,
//                   const char *stawkaE,
//                   const char *wartPTUE,
//                   const char *wartNettoF,
//                   const char *wartBruttoF,
//                   const char *stawkaF,
//                   const char *wartPTUF,
//                   const char *wartZwol,
//                   const char *wartNettoSum,
//                   const char *wartBruttoSum,
//                   const char *wartPTUSum );
CLIPPER cfFaktKoni (void);

// 13.4 Anulacja faktury
CLIPPER cfAnulujFa (void);
  //  parameters
  //    none
  //  return NUMERIC

// 13.5 Stan czujnikow papieru
// int mfFaktPaper( int *paperIn, int *paperOut );
CLIPPER cfFaktPape (void);
  //  parameters
  //    int *paperIn, int *paperOut
  //  return NUMERIC


/*********************************************************************/

// Dodatek A - Komunikacja bezposrednia z DF
// int mfAnyCommand( int outputL, char *output, int inputL, char *input, int *resultL, long timeOut );
CLIPPER cfAnyComma (void);


/*********************************************************************/

// Odczyt kodu bledu
// int mfError( void );
CLIPPER cfError ( void );
  //  parameters
  //    none
  //  return NUMERIC
